static const char rcsid[] = "$Id: acqd.c,v 1.1 2009/08/03 01:42:10 elaine Exp elaine $";


/* $Header: /home/elaine/projeto/codigo/pronto/acqd.c,v 1.1 2009/08/03 01:42:10 elaine Exp elaine $
 * $Date: 2009/08/03 01:42:10 $
 *
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia 
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de M. Silva
 * Projeto de Graduacao - Adequacao do Software 
 * de Simulacao Scicos para a Aquisicao de Dados
 * e o Controle em Tempo Real
 * -------------------------------------------------------------------------------------------
 * Modulo servidor de funcoes de aquisicao da API do projeto COMEDI
 * 
 * $Log: acqd.c,v $
 * Revision 1.1  2009/08/03 01:42:10  elaine
 * Initial revision
 * 
 * -------------------------------------------------------------------------------------------
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <comedilib.h>
#include <time.h>
#include "comedisrv.h"


#define MINHAPORTA "3490" 
#define BUFFERSIZE 1024    //tamanho maximo do buffer
#define BACKLOG 10         //enfileira ate 10 conexoes
#define MAX_PARAMS 10      // numero maximo de parametros de uma funcao comedi


int main(){
	
	int sockfd, newSockfd, stat, newSockfdStat = 1;
	char buffer[BUFFERSIZE],  *params[MAX_PARAMS];
	char s[INET6_ADDRSTRLEN];
	char tokensFound = 0;
	socklen_t sin_size;
	struct sockaddr_storage client_addr;
	time_t td;
	
	FILE *log = fopen("log.txt","a");
	if (!log){
		fprintf(stderr, "%s: Nao foi possivel abrir %s para leitura.\n",strerror(errno),"log.txt");
		exit(13);
	}

	bzero(params, MAX_PARAMS*sizeof(char));
	bzero(buffer, BUFFERSIZE*sizeof(char));
	
	//faz o bind do servidor com a porta
	sockfd = getLocalSocket();
	
	
	//escuta na porta especificada
	stat = listen(sockfd, BACKLOG);
	if (stat == -1){
		perror("listen");
		exit(1);
		}

	printf("servidor: aguardando requisicao...\n");
	
	//estabelece conexao
	while(1){ 
		sin_size = sizeof client_addr;
		newSockfd = accept(sockfd, (struct sockaddr *)&client_addr, &sin_size);
		int nodelay = 1;
		setsockopt(newSockfd,SOL_TCP,TCP_NODELAY,&nodelay,sizeof(nodelay));
		
		if(newSockfd == -1){
			perror("accept");
			continue;
			}
		//converte endereco numerico em uma string para apresentacao
		inet_ntop(client_addr.ss_family,getInAddr((struct sockaddr *)&client_addr),s,sizeof s);
		printf("servidor: conectado a %s\n",s);
		newSockfdStat = 1;

		//recebe mensagem do cliente e armazena em buffer
		getClientData(sockfd,newSockfd,buffer,BUFFERSIZE);

		time(&td);
		fprintf(log,"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
		fprintf(log,"Mensagem recebida em %s: %s\n",ctime(&td),buffer);
		fflush(log);
		

		//trata mensagem recebida e prepara para execucao de funcao do comedi
		tokensFound = parser(buffer, MAX_PARAMS,params);


		if(tokensFound < 0){
			if(tokensFound == -1){
				printf("servidor: string invalida. Tente '<IP>/comedi_funcao/par1/par2/par3...'\n");
				close(newSockfd);
				}
			if(tokensFound == -2){
				printf("servidor: primeiro argumento deve ser GET\n");
				close(newSockfd);
				}
			if(tokensFound == -3){
				printf("servidor: deve haver uma funcao comedi\n");
				close(newSockfd);
				}
			}
		else{
			//executa funcao comedi 
			execComedi(newSockfd, params);
			}

		close(newSockfd);
		}
	
	//fecha conexao
	fclose(log);
	close(sockfd);

	
}



