static const char rcsid[] = "$Id: getDriverName.c,v 1.1 2009/08/03 02:00:30 elaine Exp $";


/* $Header: /home/elaine/projeto/codigo/pronto/getDriverName.c,v 1.1 2009/08/03 02:00:30 elaine Exp $
 * $Date: 2009/08/03 02:00:30 $
 *
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia 
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de M. Silva
 * Projeto de Graduacao - Adequacao do Software 
 * de Simulacao Scicos para a Aquisicao de Dados
 * e o Controle em Tempo Real
 * -------------------------------------------------------------------------------------------
 * Parte do modulo servidor de funcoes de aquisicao da API do projeto COMEDI
 * 
 * $Log: getDriverName.c,v $
 * Revision 1.1  2009/08/03 02:00:30  elaine
 * Initial revision
 *
 * 
 * -------------------------------------------------------------------------------------------
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <comedilib.h>
#include "comedisrv.h"

void getDriverName(char *boardName, int maxLineSize, char *option, char *driverModelName){

	FILE *driverFile = fopen("comedi-driver.conf","r");
	if (!driverFile){
		fprintf(stderr, "%s: Nao foi possivel abrir %s para leitura.\n",strerror(errno),"comedi-driver.conf");
		exit(13);
	}
	char lineRead[maxLineSize], auxLineRead[maxLineSize], *nameFound;
	int found = 0;
	int tam = 0;
	const char *delimiter = ":";
	const char *driver = "driver";
	const char *model = "model";

	char *driverModelNamePtr = 0;


	while (found == 0 && fgets(lineRead,maxLineSize,driverFile) != NULL){
		
	/* le linha do arquivo de configuracao */
		bzero(auxLineRead,sizeof(char) * maxLineSize);
		bzero(driverModelName,sizeof(char) *maxLineSize);
		strcpy(auxLineRead,lineRead);
		 
		nameFound = strtok(auxLineRead,delimiter); /* pega primeiro campo */
		if(strcmp(boardName,nameFound) == 0 ){  /* se o nome da placa eh igual ao primeiro campo do arquivo  */
			if(strcmp(option,driver) == 0){ /* e se a opcao eh driver */
				
					driverModelNamePtr = strtok(NULL,delimiter); /* pega nome do modulo a ser carregado no kernel */
					strcpy(driverModelName, driverModelNamePtr);
					tam = strlen(driverModelName);
					if(driverModelName[tam-1] == '\n'){

						driverModelName[tam-1] = '\0';

						}
					found = 1;

			}

			if(strcmp(option,model) == 0){ /* se a opcao eh modelo */

				if (( driverModelNamePtr = strrchr(lineRead,':')) != 0){ /* pega nome do modelo */

					++driverModelNamePtr; /* pula ":" */
					strcpy(driverModelName, driverModelNamePtr);
					tam = strlen(driverModelName);
					found = 1;
					if(driverModelName[tam-1] == '\n'){
						driverModelName[tam-1] = '\0';
					}
				}

			}

		}

	}

	fclose(driverFile);

	

}
