static const char rcsid[] = "$Id: getLocalSocket.c,v 1.1 2009/08/03 01:58:47 elaine Exp $";


/* $Header: /home/elaine/projeto/codigo/pronto/getLocalSocket.c,v 1.1 2009/08/03 01:58:47 elaine Exp $
 * $Date: 2009/08/03 01:58:47 $
 *
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia 
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de M. Silva
 * Projeto de Graduacao - Adequacao do Software 
 * de Simulacao Scicos para a Aquisicao de Dados
 * e o Controle em Tempo Real
 * -------------------------------------------------------------------------------------------
 * Parte do modulo servidor de funcoes de aquisicao da API do projeto COMEDI
 * 
 * $Log: getLocalSocket.c,v $
 * Revision 1.1  2009/08/03 01:58:47  elaine
 * Initial revision
 *
 * 
 * -------------------------------------------------------------------------------------------
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <comedilib.h>
#include "comedisrv.h"

//getLocalSocket: faz o bind do servidor a porta especificada. Retorna socket local
int getLocalSocket(void){

	int status, sockfd;
	int yes = 1;
	struct addrinfo hints;
	struct addrinfo *servinfo,*p; //aponta para lista de resultados

	memset(&hints, 0, sizeof hints); // zera estrutura addrinfo
	hints.ai_family = AF_UNSPEC; // nao importa se eh IPv4 ou 6
	hints.ai_socktype = SOCK_STREAM; //escolhe TCP/IP
	hints.ai_flags = AI_PASSIVE; // meu IP

	//faz servinfo apontar para uma lista encadeada de 1 ou mais addrinfos.
	if ((status = getaddrinfo(NULL,MINHAPORTA,&hints,&servinfo)) != 0){
		fprintf(stderr, "getaddrinfo error: %s\n", gai_strerror(status));
		return 1;
		}

	//percorre lista e faz o bind com o primeiro resultado valido
	for(p = servinfo; p != NULL; p = p->ai_next){
		if((sockfd = socket(p->ai_family,p->ai_socktype,p->ai_protocol)) == -1){
			perror("servidor: socket");
			continue;
			}

		//evita mensagem de endereco em uso
		setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR,&yes,sizeof(int));

		if(bind(sockfd,p->ai_addr,p->ai_addrlen) == -1){
			close(sockfd);
			perror("servidor: bind");
			continue;
			}
		break;

		if(p == NULL){
			fprintf(stderr, "servidor: nao foi possivel fazer o bind no socket\n");
			return 2;
		}

		freeaddrinfo(servinfo); // libera lista encadeada
		
		} 

	return(sockfd);
}
